// package_A/page/TaskDetail/index.js
import {statusList, baseRules, orderRules} from '../../../utils/data.js'

Page({

    /**
     * 页面的初始数据
     */
    data: {
        taskIsLive: null, // 任务状态
        dataSource: {},
        statusList,
        messageList: [
            {label: '任务执行时间', value: "taskStartTime", icon: ""},
            {label: '任务地点', value: "patrolLocation", icon: ""},
            {label: '任务发起人', value: "taskName", icon: ""},
            {label: '租户名称', value: "tenantName", icon: ""},
            {label: '需要直播', value: "isLive", icon: ""},
            {label: '备注', value: "createTime", icon: ""}
        ],
        form: {},
        formRules: {},
        formOptions: {
            equipmentId: {current: -1, list: [{value: 1, label: '倾斜摄影'},
            {value: 2, label: '正射影像'}]},
            equipmentMountId: {current: -1, list: [{value: 1, label: '倾斜摄影'},
            {value: 2, label: '正射影像'}]},
            photographyWay: {current: -1, list: [{value: 1, label: '倾斜摄影'},
            {value: 2, label: '正射影像'}]},
            cloudBoxId: {current: -1, list: [{value: 1, label: '倾斜摄影'},
            {value: 2, label: '正射影像'}]}
        },
        disabled: false
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        if(options.data) {
            let dataSource = this.data.dataSource
            dataSource = JSON.parse(options.data)
            let formRules = this.data.formRules
            if(dataSource.isLive === 0) {
                formRules = Object.assign(baseRules, {})
            } else {
                formRules = Object.assign(baseRules, orderRules)
            }
            this.setData({dataSource, taskIsLive: dataSource.isLive, formRules})
        }
    },
    /**
     * 
     * @param {*} e 
     */
    updateChange(e) {
        console.log('事件触发');
        let index = e.currentTarget.dataset.index
        let current = parseInt(e.detail.value)
        let value = this.data.formOptions[index].list[current].value
        let form = this.data.form
        form[index] = value
        let formOptions = this.data.formOptions
        formOptions[index].current = current
        this.setData({formOptions, form})
        this.validate(index)
    },
    validate(name) {
          let formRules = this.data.formRules;
          let validator = formRules[name].validator
          let result = validator ? !validator(this.data.form[name]) : false;
          formRules[name].warning = result
          this.setData({
            formRules
          })
          console.log(name, result);
          return result
      },
      validateForm() {
        return new Promise((resolve, reject) => {
          try {
            let formRules = this.data.formRules;
            let result = false;
            for (let key in formRules) {
              let temp = this.validate(key)
              if (temp) {
                result = temp
              }
            }
            resolve(!result)
          } catch (e) {
            reject(e)
          }
        })
      },
})